/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of opensipsxs.xs. Do not edit this file, edit opensipsxs.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "opensipsxs.xs"
/*
 * Perl module for OpenSIPS
 *
 * Copyright (C) 2006 Collax GmbH
 *                    (Bastian Friedrich <bastian.friedrich@collax.com>)
 *
 * This file is part of opensips, a free SIP server.
 *
 * opensips is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * opensips is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 */

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>
#include <unistd.h>
#undef load_module

/* perl.h defines union semun */
#ifdef USE_SYSV_SEM
# undef _SEM_SEMUN_UNDEFINED
#endif

#include "../../sr_module.h"
#include "../../parser/msg_parser.h"
#include "../../parser/parse_uri.h"
#include "../../usr_avp.h"
#include "../../action.h"
#include "../../flags.h"
#include "../../pvar.h"
#include "../../mem/mem.h"
#include "../../route_struct.h"
#include "../../serialize.h"
#include "../../qvalue.h"
#include "../../dprint.h"
#include "../../mod_fix.h"
#include "../../ut.h"

enum xs_uri_members {
	XS_URI_USER = 0,
	XS_URI_PASSWD,
	XS_URI_HOST,
	XS_URI_PORT,
	XS_URI_PARAMS,
	XS_URI_HEADERS,
	XS_URI_TRANSPORT,
	XS_URI_TTL,
	XS_URI_USER_PARAM,
	XS_URI_MADDR,
	XS_URI_METHOD,
	XS_URI_LR,
	XS_URI_R2,
	XS_URI_TRANSPORT_VAL,
	XS_URI_TTL_VAL,
	XS_URI_USER_PARAM_VAL,
	XS_URI_MADDR_VAL,
	XS_URI_METHOD_VAL,
	XS_URI_LR_VAL,
	XS_URI_R2_VAL
	
	/* These members are no strings:
		unsigned short port_no;
	unsigned short proto; / * from transport * /
	uri_type type; / * uri scheme */
};

/*
 * Return the sip_msg struct referred to by perl reference sv
 */
struct sip_msg * sv2msg(SV *sv) {
	struct sip_msg* m;
	if (SvROK(sv)) {
		sv = SvRV(sv);
		if (SvIOK(sv)) {
			m = INT2PTR(struct sip_msg*, SvIV(sv));
			return m;
		}
	}
	return NULL; /* In case of error above... */
}

struct sip_uri * sv2uri(SV *sv) {
	struct sip_uri* u;
	if (SvROK(sv)) {
		sv = SvRV(sv);
		if (SvIOK(sv)) {
			u = INT2PTR(struct sip_uri*, SvIV(sv));
			return u;
		}
	}
	return NULL; /* In case of error above... */
}

struct action * sv2action(SV *sv) {
	struct action* a;
	if (SvROK(sv)) {
		sv = SvRV(sv);
		if (SvIOK(sv)) {
			a = INT2PTR(struct action*, SvIV(sv));
			return a;
		}
	}
	return NULL; /* In case of error above... */
}

/*
 * We have a private function for two reasons:
 * a) Return SIP_INVALID even if type was sth different
 * b) easy access
 */

inline static int getType(struct sip_msg *msg) {
	int t = SIP_INVALID;

	if (!msg) return SIP_INVALID;

	switch ((msg->first_line).type) {
		case SIP_REQUEST:	t = SIP_REQUEST; break;
		case SIP_REPLY:		t = SIP_REPLY; break;
	}
	return t;
}
		

SV *getStringFromURI(SV *self, enum xs_uri_members what) {
	struct sip_uri *myuri = sv2uri(self);
	str *ret = NULL;

	if (!myuri) {
		LM_ERR("Invalid URI reference\n");
		ret = NULL;
	} else {
		
		switch (what) {
			case XS_URI_USER:	ret = &(myuri->user);
						break;
			case XS_URI_HOST:	ret = &(myuri->host);
						break;
			case XS_URI_PASSWD:	ret = &(myuri->passwd);
						break;
			case XS_URI_PORT:	ret = &(myuri->port);
						break;
			case XS_URI_PARAMS:	ret = &(myuri->params);
						break;
			case XS_URI_HEADERS:	ret = &(myuri->headers);
						break;
			case XS_URI_TRANSPORT:	ret = &(myuri->transport);
						break;
			case XS_URI_TTL:		ret = &(myuri->ttl);
						break;
			case XS_URI_USER_PARAM:	ret = &(myuri->user_param);
						break;
			case XS_URI_MADDR:	ret = &(myuri->maddr);
						break;
			case XS_URI_METHOD:	ret = &(myuri->method);
						break;
			case XS_URI_LR:		ret = &(myuri->lr);
						break;
			case XS_URI_R2:		ret = &(myuri->r2);
						break;
			case XS_URI_TRANSPORT_VAL:	ret = &(myuri->transport_val);
						break;
			case XS_URI_TTL_VAL:	ret = &(myuri->ttl_val);
						break;
			case XS_URI_USER_PARAM_VAL:	ret = &(myuri->user_param_val);
						break;
			case XS_URI_MADDR_VAL:	ret = &(myuri->maddr_val);
						break;
			case XS_URI_METHOD_VAL:	ret = &(myuri->method_val);
						break;
			case XS_URI_LR_VAL:	ret = &(myuri->lr_val);
						break;
			case XS_URI_R2_VAL:	ret = &(myuri->r2_val);
						break;

			default:	LM_INFO("Unknown URI element"
						" requested: %d\n", what);
					break;
		}
	}

	if ((ret) && (ret->len)) {
		return sv_2mortal(newSVpv(ret->s, ret->len));
	} else {
		return &PL_sv_undef;
	}
}


static int perl_do_action(struct sip_msg* msg, struct action *act,
    cmd_export_t *cmd, int *retval)
{
    void* cmdp[MAX_CMD_PARAMS];
    pv_value_t tmp_vals[MAX_CMD_PARAMS];
    int i;
    struct cmd_param *param;
    gparam_p gp;

    if (fix_cmd(cmd->params, act->elem) < 0) {
		LM_ERR("failed to fix command '%s'\n", cmd->name);
		return -1;
	}

	if (get_cmd_fixups(msg, cmd->params, act->elem, cmdp, tmp_vals) < 0) {
		LM_ERR("failed to get fixups for command '%s'\n", cmd->name);
		return -1;
	}

	*retval = cmd->function(msg,
		cmdp[0],cmdp[1],cmdp[2],
		cmdp[3],cmdp[4],cmdp[5],
		cmdp[6],cmdp[7]);

	for (param=cmd->params, i=1; param->flags; param++, i++) {
		gp = (gparam_p)act->elem[i].u.data;
		if (!gp)
			continue;

		if (param->free_fixup && param->free_fixup(&cmdp[i-1]) < 0) {
			LM_ERR("failed to free fixups for command '%s'\n", cmd->name);
			return -1;
		}

		if (param->flags & CMD_PARAM_REGEX && gp->type != GPARAM_TYPE_PVS) {
			regfree((regex_t*)cmdp[i-1]);
			pkg_free(cmdp[i-1]);
		}
	}

    return 0;
}

/*
 * Calls an exported function.
 *
 * Return codes:
 *   -1 - Function not available (or other error).
 *    1 - Function was called. Its return value is returned via the retval
 *        parameter.
 */

int moduleFunc(struct sip_msg *m, char *func, char **pargs, int *retval)
{
	cmd_export_t *exp_func_struct;
	struct action *act;
	action_elem_t elems[MAX_ACTION_ELEMS];
	int i, n = 0;
	struct cmd_param *param;
	str s;
	pv_spec_t *specs[MAX_CMD_PARAMS];
	int rval;

	if (!func) {
		LM_ERR("moduleFunc called with null function name. Error.\n");
		return -1;
	}

	exp_func_struct = find_cmd_export_t(func, 0);
	if (!exp_func_struct) {
		LM_ERR("function '%s' called, but not available\n", func);
		*retval = -1;
		return -1;
	}

	for (i=0; i < MAX_CMD_PARAMS; i++) {
		if (pargs[i]) {
			n++;
			if (strlen(pargs[i]) == 0)  /* 'undef' argument */ {
				elems[i+1].type = NULLV_ST;
				pargs[i] = NULL;
			} else
				elems[i+1].type = NOSUBTYPE;
		}
		specs[i] = NULL;
	}

	rval = check_cmd_call_params(exp_func_struct, elems, n);
	if (rval == -1 || rval == -2) {
		LM_ERR("to few or too many parameters\n");
		*retval = -1;
		return -1;
	} else if (rval == -3) {
		LM_ERR("mandatory parameter ommited\n");
		*retval = -1;
		return -1;
	}

	elems[0].type = CMD_ST;
	elems[0].u.data = exp_func_struct;

	for (param=exp_func_struct->params, i=1; param->flags; param++, i++) {
		if (!pargs[i-1])
			continue;

		if (param->flags & CMD_PARAM_INT) {
			elems[i].type = NUMBER_ST;
			s.s = pargs[i-1];
		    s.len =  strlen(s.s);
			if (str2sint(&s, (int*)&elems[i].u.number) < 0) {
				LM_ERR("parameter [%d] should be an integer\n", i);
				*retval = -1;
				return -1;
			}
		} else if (param->flags & (CMD_PARAM_STR | CMD_PARAM_REGEX)) {
			elems[i].type = STR_ST;
			elems[i].u.data = pargs[i-1];
		} else if (param->flags & CMD_PARAM_VAR) {
			elems[i].type = SCRIPTVAR_ST;
			specs[i] = pkg_malloc(sizeof *specs[i]);
			if (!specs[i]) {
				LM_ERR("oom\n");
				*retval = -1;
				return -1;
			}
			s.s = pargs[i-1];
			s.len = strlen(s.s);
			if (pv_parse_spec(&s, specs[i]) == NULL) {
				LM_ERR("unknown script variable: %.*s\n", s.len, s.s);
				*retval = -1;
				return -1;
			}
			elems[i].u.data = specs[i];
		}
	}

	act = mk_action(MODULE_T, n+1, elems, 0, "perl");

	if (!act) {
		LM_ERR("action structure could not be created. Error.\n");
		*retval = -1;
		return -1;
	}

	if (perl_do_action(m, act, exp_func_struct, retval) < 0) {
		*retval = -1;
		return -1;
	}

	for (i=0; i < MAX_CMD_PARAMS; i++)
		pv_spec_free(specs[i]);

	/* free the gparam_t structs allocated by fix_cmd() */
	for (i=1; i < MAX_ACTION_ELEMS; i++)
		if (act->elem[i].u.data)
			pkg_free(act->elem[i].u.data);

	pkg_free(act);
	
	return 1;
}


/**
 * Rewrite Request-URI
 */
static inline int rewrite_ruri(struct sip_msg* _m, char* _s)
{
	struct action act;

	memset(&act, 0, sizeof(act));
	act.type = SET_URI_T;
	act.elem[0].type = STR_ST;
	act.elem[0].u.s.s = _s;
	act.elem[0].u.s.len = strlen(_s);
	act.next = 0;
	
	if (do_action(&act, _m) < 0)
	{
		LM_ERR("rewrite_ruri: Error in do_action\n");
		return -1;
	}
	return 0;
}


/**
 * Compile a string with pseudo variables substituted by their values.
 * A string buffer is allocated. Deallocate afterwards!
 */
char *pv_sprintf(struct sip_msg *m, char *fmt) {
	int buf_size = 4096;
	pv_elem_t *model;
	str s;
	char *out = (char *)pkg_malloc(buf_size);
	char *ret = NULL;

	if (!out) {
		LM_ERR("pv_sprintf: Memory exhausted!\n");
		return NULL;
	}

	s.s = fmt; s.len = strlen(s.s);
	if(pv_parse_format(&s, &model) < 0) {
		LM_ERR("pv_sprintf: ERROR: wrong format[%s]!\n",
			fmt);
		return NULL;
	}

	if(pv_printf(m, model, out, &buf_size) < 0) {
		ret = NULL;
	} else {
		ret = strdup(out);
	}

	pv_elem_free_all(model);
	pkg_free(out);

	return ret;
}

/**
 * Convert an SV to an int_str struct. Needed in AVP package.
 * - val: SV to convert.
 * - is: pointer to resulting int_str
 * - flags: pointer to flags to set
 * - strflag: flag mask to be or-applied for string match
 */

static inline int sv2int_str(SV *val, int_str *is,
		      unsigned short *flags, unsigned short strflag) {
	char *s;
	STRLEN len;

	if (!SvOK(val)) {
		LM_ERR("AVP:sv2int_str: Invalid value "
			"(not a scalar).\n");
		return 0;
	}
	
	if (SvIOK(val)) { /* numerical name */
		is->n = SvIV(val);
		*flags = 0;
		return 1;
	} else if (SvPOK(val)) {
		s = SvPV(val, len);
		is->s.len = len;
		is->s.s = s;
		(*flags) |= strflag;
		return 1;
	} else {
		LM_ERR("AVP:sv2int_str: Invalid value "
			"(neither string nor integer).\n");
		return 0;
	}
}

/* ************************************************************************ */
/* Object methods begin here */

#if 0
  "Skipped embedded POD."
#endif
#line 469 "opensipsxs.xs"

#line 477 "opensipsxs.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 621 "opensipsxs.c"

XS_EUPXS(XS_OpenSIPS_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS_log)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "level, log");
    {
	int	level = (int)SvIV(ST(0))
;
	char *	log = (char *)SvPV_nolen(ST(1))
;
#line 499 "opensipsxs.xs"
#line 635 "opensipsxs.c"
#line 500 "opensipsxs.xs"
#line 637 "opensipsxs.c"
#line 501 "opensipsxs.xs"
	switch (level) {
	case L_ALERT:	LM_ALERT("%s", log); break;
	case L_CRIT:	LM_CRIT("%s", log); break;
	case L_ERR:	LM_ERR("%s", log); break;
	case L_WARN:	LM_WARN("%s", log); break;
	case L_NOTICE:	LM_NOTICE("%s", log); break;
	case L_INFO:	LM_INFO("%s", log); break;
	default:	LM_DBG("%s", log); break;
	}
#line 648 "opensipsxs.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_OpenSIPS__Message_getType); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getType)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 537 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
#line 665 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 539 "opensipsxs.xs"
#line 669 "opensipsxs.c"
#line 540 "opensipsxs.xs"
  	RETVAL = getType(msg);
#line 672 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getStatus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getStatus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 557 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *ret;
#line 691 "opensipsxs.c"
	SV *	RETVAL;
#line 560 "opensipsxs.xs"
#line 694 "opensipsxs.c"
#line 561 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) != SIP_REPLY) {
			LM_ERR("getStatus: Status not available in"
				" non-reply messages.");
			ST(0) = &PL_sv_undef;
		} else {
			ret = &((msg->first_line).u.reply.status);
			ST(0) = sv_2mortal(newSVpv(ret->s, ret->len));
		}
	}
#line 709 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getReason); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getReason)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 587 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *ret;
#line 727 "opensipsxs.c"
	SV *	RETVAL;
#line 590 "opensipsxs.xs"
#line 730 "opensipsxs.c"
#line 591 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) != SIP_REPLY) {
			LM_ERR("getReason: Reason not available in"
				" non-reply messages.");
			ST(0) = &PL_sv_undef;
		} else {
			ret = &((msg->first_line).u.reply.reason);
			ST(0) = sv_2mortal(newSVpv(ret->s, ret->len));
		}
	}
#line 745 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getVersion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getVersion)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 616 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *ret;
#line 763 "opensipsxs.c"
	SV *	RETVAL;
#line 619 "opensipsxs.xs"
#line 766 "opensipsxs.c"
#line 620 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) == SIP_REQUEST) {
			ret = &((msg->first_line).u.request.version);
		} else { /* SIP_REPLY */
			ret = &((msg->first_line).u.reply.version);
		}
		ST(0) = sv_2mortal(newSVpv(ret->s, ret->len));
	}
#line 779 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getRURI); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getRURI)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 650 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *ret;
#line 797 "opensipsxs.c"
	SV *	RETVAL;
#line 653 "opensipsxs.xs"
#line 800 "opensipsxs.c"
#line 654 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) != SIP_REQUEST) {
			LM_ERR("Not a request message - "
				"no RURI available.\n");
			ST(0) = &PL_sv_undef;
		} else {
			ret = &((msg->first_line).u.request.uri);
			ST(0) = sv_2mortal(newSVpv(ret->s, ret->len));
		}
	}
#line 815 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getMethod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getMethod)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 683 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *ret;
#line 833 "opensipsxs.c"
	char *	RETVAL;
	dXSTARG;
#line 686 "opensipsxs.xs"
#line 837 "opensipsxs.c"
#line 687 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) != SIP_REQUEST) {
			LM_ERR("Not a request message - "
				"no method available.\n");
			ST(0) = &PL_sv_undef;
		} else {
			ret = &((msg->first_line).u.request.method);
			ST(0) = sv_2mortal(newSVpv(ret->s, ret->len));
		}
	}
#line 852 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getFullHeader); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getFullHeader)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 716 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    char *firsttoken;
    long headerlen;
#line 871 "opensipsxs.c"
	SV *	RETVAL;
#line 720 "opensipsxs.xs"
#line 874 "opensipsxs.c"
#line 721 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		if (getType(msg) == SIP_INVALID) {
			LM_ERR("getFullHeader: Invalid message type.\n");
			ST(0)  = &PL_sv_undef;
		} else {
			if (parse_headers(msg, ~0, 0) < 0)
				LM_ERR("cannot parse headers\n");
			if (getType(msg) == SIP_REQUEST) {
				firsttoken = (msg->first_line).u.request.method.s;
			} else { /* SIP_REPLY */
				firsttoken = (msg->first_line).u.reply.version.s;
			}

			if (msg->eoh == NULL)
				headerlen = 0;
			else
				headerlen = ((long)(msg->eoh))
						-((long)(firsttoken));

			if (headerlen > 0) {
				ST(0) = 
				    sv_2mortal(newSVpv(firsttoken, headerlen));
			} else {
				ST(0) = &PL_sv_undef;
			}
		}
	}
#line 906 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getBody); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getBody)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 763 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str body;
#line 924 "opensipsxs.c"
	SV *	RETVAL;
#line 766 "opensipsxs.xs"
#line 927 "opensipsxs.c"
#line 767 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		body.s = NULL;
		if (get_body(msg,&body) < 0) {
			LM_ERR("Message has no body\n");
			ST(0) = &PL_sv_undef;
		} else {
			ST(0) = sv_2mortal(newSVpv(body.s, 0));
		}
	}
#line 941 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getMessage); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getMessage)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 791 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
#line 958 "opensipsxs.c"
	SV *	RETVAL;
#line 793 "opensipsxs.xs"
#line 961 "opensipsxs.c"
#line 794 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		ST(0) = sv_2mortal(newSVpv(msg->buf, 0));
	}
#line 969 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getHeader); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getHeader)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 817 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    str *body = NULL;
    struct hdr_field *hf;
    int found = 0;
    int namelen = strlen(name);
#line 994 "opensipsxs.c"
	SV *	RETVAL;
#line 823 "opensipsxs.xs"
#line 997 "opensipsxs.c"
#line 824 "opensipsxs.xs"
	LM_DBG("searching '%s'\n", name);

	if (!msg) {
		LM_ERR("Invalid message reference\n");
	} else {
		if (parse_headers(msg, ~0, 0) < 0)
			LM_ERR("cannot parse headers!\n");
		for (hf = msg->headers; hf; hf = hf->next) {
			if (namelen == hf->name.len) {
				if (strncmp(name, hf->name.s, namelen) == 0) {
					/* Found the right header. */
					found = 1;
					body = &(hf->body);
					XPUSHs(sv_2mortal(newSVpv(body->s,
								  body->len)));
				}
			}
		}
	}
	if (!found) {
		XPUSHs(&PL_sv_undef);
	}
#line 1021 "opensipsxs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_OpenSIPS__Message_getHeaderNames); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getHeaderNames)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
#line 859 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    struct hdr_field *hf = NULL;
    int found = 0;
#line 1043 "opensipsxs.c"
	AV *	RETVAL;
#line 864 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
	} else {
		if (parse_headers(msg, ~0, 0) < 0)
			LM_ERR("cannot parse headers!\n");
		for (hf = msg->headers; hf; hf = hf->next) {
			found = 1;
			XPUSHs(sv_2mortal(newSVpv(hf->name.s, hf->name.len)));
		}
	}
	if (!found) {
		XPUSHs(&PL_sv_undef);
	}
#line 1059 "opensipsxs.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_OpenSIPS__Message_moduleFunction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_moduleFunction)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 10)
       croak_xs_usage(cv,  "self, func, string1 = NULL, string2 = NULL, string3 = NULL, string4 = NULL, string5 = NULL, string6 = NULL, string7 = NULL, string8 = NULL");
    {
	SV *	self = ST(0)
;
	char *	func = (char *)SvPV_nolen(ST(1))
;
	char *	string1;
	char *	string2;
	char *	string3;
	char *	string4;
	char *	string5;
	char *	string6;
	char *	string7;
	char *	string8;
#line 912 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    int retval; /* Return value of called function */
    int ret;    /* Return value of moduleFunc - < 0 for "non existing function" and other errors */
    char *pargs[MAX_CMD_PARAMS];
#line 1090 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    string1 = NULL;
	else {
	    string1 = (char *)SvPV_nolen(ST(2))
;
	}

	if (items < 4)
	    string2 = NULL;
	else {
	    string2 = (char *)SvPV_nolen(ST(3))
;
	}

	if (items < 5)
	    string3 = NULL;
	else {
	    string3 = (char *)SvPV_nolen(ST(4))
;
	}

	if (items < 6)
	    string4 = NULL;
	else {
	    string4 = (char *)SvPV_nolen(ST(5))
;
	}

	if (items < 7)
	    string5 = NULL;
	else {
	    string5 = (char *)SvPV_nolen(ST(6))
;
	}

	if (items < 8)
	    string6 = NULL;
	else {
	    string6 = (char *)SvPV_nolen(ST(7))
;
	}

	if (items < 9)
	    string7 = NULL;
	else {
	    string7 = (char *)SvPV_nolen(ST(8))
;
	}

	if (items < 10)
	    string8 = NULL;
	else {
	    string8 = (char *)SvPV_nolen(ST(9))
;
	}
#line 917 "opensipsxs.xs"
#line 1150 "opensipsxs.c"
#line 918 "opensipsxs.xs"
	LM_DBG("Calling exported func: '%s'\n", func);

	pargs[0] = string1;
	pargs[1] = string2;
	pargs[2] = string3;
	pargs[3] = string4;
	pargs[4] = string5;
	pargs[5] = string6;
	pargs[6] = string7;
	pargs[7] = string8;

	if (!msg) {
		LM_ERR("invalid message received!\n");
		retval = -1;
	} else {
		ret = moduleFunc(msg, func, pargs, &retval);
		if (ret < 0) {
			LM_ERR("calling module function '%s' failed."
				" Missing loadmodule?\n", func);
			retval = -1;
		}
	}
	RETVAL = retval;
#line 1175 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, level, log");
    {
	SV *	self = ST(0)
;
	int	level = (int)SvIV(ST(1))
;
	char *	log = (char *)SvPV_nolen(ST(2))
;
#line 970 "opensipsxs.xs"
#line 1196 "opensipsxs.c"
#line 971 "opensipsxs.xs"
#line 1198 "opensipsxs.c"
#line 972 "opensipsxs.xs"
	switch (level) {
	case L_ALERT:	LM_ALERT("%s", log); break;
	case L_CRIT:	LM_CRIT("%s", log); break;
	case L_ERR:	LM_ERR("%s", log); break;
	case L_WARN:	LM_WARN("%s", log); break;
	case L_NOTICE:	LM_NOTICE("%s", log); break;
	case L_INFO:	LM_INFO("%s", log); break;
	default:	LM_DBG("%s", log); break;
	}
#line 1209 "opensipsxs.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_OpenSIPS__Message_rewrite_ruri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_rewrite_ruri)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, newruri");
    {
	SV *	self = ST(0)
;
	char *	newruri = (char *)SvPV_nolen(ST(1))
;
#line 1000 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
#line 1228 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1002 "opensipsxs.xs"
#line 1232 "opensipsxs.c"
#line 1003 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		if (getType(msg) != SIP_REQUEST) {
			LM_ERR("Not a Request. RURI rewrite unavailable.\n");
			RETVAL = -1;
		} else {
			LM_DBG("New R-URI is [%s]\n", newruri);
			RETVAL = rewrite_ruri(msg, newruri);
		}
	}
#line 1246 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_setFlag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_setFlag)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, flag");
    {
	SV *	self = ST(0)
;
	unsigned int	flag = (unsigned int)SvUV(ST(1))
;
#line 1032 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
#line 1266 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1034 "opensipsxs.xs"
#line 1270 "opensipsxs.c"
#line 1035 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = setflag(msg, flag);
	}
#line 1278 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_resetFlag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_resetFlag)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, flag");
    {
	SV *	self = ST(0)
;
	unsigned int	flag = (unsigned int)SvUV(ST(1))
;
#line 1056 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
#line 1298 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1058 "opensipsxs.xs"
#line 1302 "opensipsxs.c"
#line 1059 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = resetflag(msg, flag);
	}
#line 1310 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_isFlagSet); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_isFlagSet)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, flag");
    {
	SV *	self = ST(0)
;
	unsigned int	flag = (unsigned int)SvUV(ST(1))
;
#line 1079 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
#line 1330 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1081 "opensipsxs.xs"
#line 1334 "opensipsxs.c"
#line 1082 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = isflagset(msg, flag) == 1 ? 1 : 0;
	}
#line 1342 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_pseudoVar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_pseudoVar)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, varstring");
    {
	SV *	self = ST(0)
;
	char *	varstring = (char *)SvPV_nolen(ST(1))
;
#line 1106 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
	char *ret;
#line 1363 "opensipsxs.c"
	SV *	RETVAL;
#line 1109 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = &PL_sv_undef;
	} else {
		ret = pv_sprintf(msg, varstring);
		if (ret) {
			ST(0) = sv_2mortal(newSVpv(ret, strlen(ret)));
			free(ret);
		} else {
			ST(0) = &PL_sv_undef;
		}
	}
#line 1378 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_append_branch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_append_branch)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "self, branch = NULL, qval = NULL");
    {
	SV *	self = ST(0)
;
	char *	branch;
	char *	qval;
#line 1136 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
	action_elem_t elems[MAX_ACTION_ELEMS];
	qvalue_t q;
	int err = 0;
	struct action *act = NULL;
#line 1401 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    branch = NULL;
	else {
	    branch = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    qval = NULL;
	else {
	    qval = (char *)SvPV_nolen(ST(2))
;
	}
#line 1142 "opensipsxs.xs"
#line 1419 "opensipsxs.c"
#line 1143 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = 1;
		if (qval) {
			if (str2q(&q, qval, strlen(qval)) < 0) {
				LM_ERR("append_branch: Bad q value.\n");
			} else { /* branch and qval set */
				elems[0].type = STR_ST;
				elems[0].u.data = branch;
				elems[1].type = NUMBER_ST;
				elems[1].u.data = (void *)(long)q;
				act = mk_action(APPEND_BRANCH_T,
						2,
						elems,
						0,
						"perl");
			}
		} else {
			if (branch) { /* branch set, qval unset */
				elems[0].type = STR_ST;
				elems[0].u.data = branch;
				elems[1].type = NUMBER_ST;
				elems[1].u.data = (void *)Q_UNSPECIFIED;
				act = mk_action(APPEND_BRANCH_T,
						2,
						elems,
						0,
						"perl");
			} else { /* neither branch nor qval set */
				elems[0].type = STR_ST;
				elems[0].u.data = NULL;
				elems[1].type = NUMBER_ST;
				elems[1].u.data = (void *)Q_UNSPECIFIED;
				act = mk_action(APPEND_BRANCH_T,
						2,
						elems,
						0,
						"perl");
			}
		}

		if (act) {
			RETVAL = do_action(act, msg);
		} else {
			RETVAL = -1;
		}
	}
#line 1470 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_serialize_branches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_serialize_branches)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, clean_before, keep_order");
    {
	SV *	self = ST(0)
;
	int	clean_before = (int)SvIV(ST(1))
;
	int	keep_order = (int)SvIV(ST(2))
;
#line 1208 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
#line 1492 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1210 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = serialize_branches(msg, clean_before, keep_order);
	}
#line 1502 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_next_branches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_next_branches)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1231 "opensipsxs.xs"
	struct sip_msg *msg = sv2msg(self);
#line 1520 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1233 "opensipsxs.xs"
  	if (!msg) {
		LM_ERR("Invalid message reference\n");
		RETVAL = -1;
	} else {
		RETVAL = next_branches(msg);
	}
#line 1530 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__Message_getParsedRURI); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__Message_getParsedRURI)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1255 "opensipsxs.xs"
    struct sip_msg *msg = sv2msg(self);
    struct sip_uri *uri;
    SV *ret;
#line 1550 "opensipsxs.c"
	SV *	RETVAL;
#line 1259 "opensipsxs.xs"
#line 1553 "opensipsxs.c"
#line 1260 "opensipsxs.xs"
	if (!msg) {
		LM_ERR("Invalid message reference\n");
		ST(0) = NULL;
	} else {
		if (parse_sip_msg_uri(msg) < 0 || parse_headers(msg, ~0, 0) < 0) {
			LM_ERR("cannot parse message uri!\n");
			ST(0) = &PL_sv_undef;
		} else {
			uri = &(msg->parsed_uri);
			ret = sv_newmortal();
			sv_setref_pv(ret, "OpenSIPS::URI", (void *)uri);
			SvREADONLY_on(SvRV(ret));

			ST(0) = ret;
		}
	}
#line 1571 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_user); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_user)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1300 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_USER);
#line 1589 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_host); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_host)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1313 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_HOST);
#line 1607 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_passwd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_passwd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1326 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_PASSWD);
#line 1625 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1339 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_PORT);
#line 1643 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_params); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_params)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1352 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_PARAMS);
#line 1661 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_headers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_headers)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1365 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_HEADERS);
#line 1679 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_transport); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_transport)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1378 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_TRANSPORT);
#line 1697 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_ttl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_ttl)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1391 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_TTL);
#line 1715 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_user_param); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_user_param)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1404 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_USER_PARAM);
#line 1733 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_maddr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_maddr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1418 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_MADDR);
#line 1751 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_method)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1430 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_METHOD);
#line 1769 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_lr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_lr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1443 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_LR);
#line 1787 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_r2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_r2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1456 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_R2);
#line 1805 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_transport_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_transport_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1469 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_TRANSPORT_VAL);
#line 1823 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_ttl_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_ttl_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1482 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_TTL_VAL);
#line 1841 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_user_param_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_user_param_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1495 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_USER_PARAM_VAL);
#line 1859 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_maddr_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_maddr_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1508 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_MADDR_VAL);
#line 1877 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_method_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_method_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1521 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_METHOD_VAL);
#line 1895 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_lr_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_lr_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1534 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_LR_VAL);
#line 1913 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__URI_r2_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__URI_r2_val)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 1547 "opensipsxs.xs"
	ST(0) = getStringFromURI(self, XS_URI_R2_VAL);
#line 1931 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__AVP_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__AVP_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p_name, p_val");
    {
	SV *	p_name = ST(0)
;
	SV *	p_val = ST(1)
;
#line 1591 "opensipsxs.xs"
	int_str name;
	int_str val;
	unsigned short flags = 0;
	char *s;
	STRLEN len;
#line 1954 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1597 "opensipsxs.xs"
  	RETVAL = 0;
	if (SvOK(p_name) && SvOK(p_val)) {
		if (!sv2int_str(p_name, &name, &flags, AVP_NAME_STR)) {
			RETVAL = -1;
		} else if (!sv2int_str(p_val, &val, &flags, AVP_VAL_STR)) {
			RETVAL = -1;
		}

		if (RETVAL == 0) {
			if (flags & AVP_NAME_STR) {
				name.n = get_avp_id(&name.s);
			}
			RETVAL = add_avp(flags, name.n, val);
		}
	}
#line 1973 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__AVP_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__AVP_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p_name");
    {
	SV *	p_name = ST(0)
;
#line 1631 "opensipsxs.xs"
	struct usr_avp *first_avp;
	int_str name;
	int_str val;
	unsigned short flags = 0;
	SV *ret = &PL_sv_undef;
	int err = 0;
	char *s;
	STRLEN len;
#line 1998 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1640 "opensipsxs.xs"
	if (SvOK(p_name)) {
		if (!sv2int_str(p_name, &name, &flags, AVP_NAME_STR)) {
			LM_ERR("AVP:get: Invalid name.\n");
			err = 1;
		}
	} else {
		LM_ERR("AVP:get: Invalid name.\n");
		err = 1;
	}

	if (err == 0) {
		if (flags & AVP_NAME_STR) {
			name.n = get_avp_id(&name.s);
		}
		first_avp = search_first_avp(flags, name.n, &val, NULL);

		if (first_avp != NULL) { /* found correct AVP */
			if (is_avp_str_val(first_avp)) {
				ret = sv_2mortal(newSVpv(val.s.s, val.s.len));
			} else {
				ret = sv_2mortal(newSViv(val.n));
			}
		} else {
			/* Empty AVP requested. */
		}
	}

	ST(0) = ret;
#line 2030 "opensipsxs.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_OpenSIPS__AVP_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_OpenSIPS__AVP_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p_name");
    {
	SV *	p_name = ST(0)
;
#line 1685 "opensipsxs.xs"
	struct usr_avp *first_avp;
	int_str name;
	int_str val;
	unsigned short flags = 0;
	SV *ret = &PL_sv_undef;
	char *s;
	STRLEN len;
#line 2053 "opensipsxs.c"
	int	RETVAL;
	dXSTARG;
#line 1693 "opensipsxs.xs"
	RETVAL = 1;
	if (SvOK(p_name)) {
		if (!sv2int_str(p_name, &name, &flags, AVP_NAME_STR)) {
			RETVAL = 0;
			LM_ERR("AVP:destroy: Invalid name.\n");
		}
	} else {
		RETVAL = 0;
		LM_ERR("VP:destroy: Invalid name.\n");
	}

	if (RETVAL == 1) {
		if (flags & AVP_NAME_STR) {
			name.n = get_avp_id(&name.s);
		}
		first_avp = search_first_avp(flags, name.n, &val, NULL);

		if (first_avp != NULL) { /* found correct AVP */
			destroy_avp(first_avp);
		} else {
			RETVAL = 0;
			/* Empty AVP requested. */
		}
	}

#line 2082 "opensipsxs.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_OpenSIPS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_OpenSIPS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("OpenSIPS::log", XS_OpenSIPS_log);
        (void)newXSproto_portable("OpenSIPS::Message::getType", XS_OpenSIPS__Message_getType, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getStatus", XS_OpenSIPS__Message_getStatus, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getReason", XS_OpenSIPS__Message_getReason, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getVersion", XS_OpenSIPS__Message_getVersion, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getRURI", XS_OpenSIPS__Message_getRURI, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getMethod", XS_OpenSIPS__Message_getMethod, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getFullHeader", XS_OpenSIPS__Message_getFullHeader, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getBody", XS_OpenSIPS__Message_getBody, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getMessage", XS_OpenSIPS__Message_getMessage, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getHeader", XS_OpenSIPS__Message_getHeader, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::getHeaderNames", XS_OpenSIPS__Message_getHeaderNames, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::moduleFunction", XS_OpenSIPS__Message_moduleFunction, file, "$$;$$$$$$$$");
        (void)newXSproto_portable("OpenSIPS::Message::log", XS_OpenSIPS__Message_log, file, "$$$");
        (void)newXSproto_portable("OpenSIPS::Message::rewrite_ruri", XS_OpenSIPS__Message_rewrite_ruri, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::setFlag", XS_OpenSIPS__Message_setFlag, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::resetFlag", XS_OpenSIPS__Message_resetFlag, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::isFlagSet", XS_OpenSIPS__Message_isFlagSet, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::pseudoVar", XS_OpenSIPS__Message_pseudoVar, file, "$$");
        (void)newXSproto_portable("OpenSIPS::Message::append_branch", XS_OpenSIPS__Message_append_branch, file, "$;$$");
        (void)newXSproto_portable("OpenSIPS::Message::serialize_branches", XS_OpenSIPS__Message_serialize_branches, file, "$$$");
        (void)newXSproto_portable("OpenSIPS::Message::next_branches", XS_OpenSIPS__Message_next_branches, file, "$");
        (void)newXSproto_portable("OpenSIPS::Message::getParsedRURI", XS_OpenSIPS__Message_getParsedRURI, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::user", XS_OpenSIPS__URI_user, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::host", XS_OpenSIPS__URI_host, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::passwd", XS_OpenSIPS__URI_passwd, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::port", XS_OpenSIPS__URI_port, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::params", XS_OpenSIPS__URI_params, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::headers", XS_OpenSIPS__URI_headers, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::transport", XS_OpenSIPS__URI_transport, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::ttl", XS_OpenSIPS__URI_ttl, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::user_param", XS_OpenSIPS__URI_user_param, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::maddr", XS_OpenSIPS__URI_maddr, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::method", XS_OpenSIPS__URI_method, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::lr", XS_OpenSIPS__URI_lr, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::r2", XS_OpenSIPS__URI_r2, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::transport_val", XS_OpenSIPS__URI_transport_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::ttl_val", XS_OpenSIPS__URI_ttl_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::user_param_val", XS_OpenSIPS__URI_user_param_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::maddr_val", XS_OpenSIPS__URI_maddr_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::method_val", XS_OpenSIPS__URI_method_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::lr_val", XS_OpenSIPS__URI_lr_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::URI::r2_val", XS_OpenSIPS__URI_r2_val, file, "$");
        (void)newXSproto_portable("OpenSIPS::AVP::add", XS_OpenSIPS__AVP_add, file, "$$");
        (void)newXSproto_portable("OpenSIPS::AVP::get", XS_OpenSIPS__AVP_get, file, "$");
        (void)newXSproto_portable("OpenSIPS::AVP::destroy", XS_OpenSIPS__AVP_destroy, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

